'- the loader isn't complete at the moment, it loads only the first object
'  of a plg-file. i'm working on this. when it's done, i'll put everything in
'  a lib, add some cool 2d-stuff, and distribute it as InDirectQB =)
'- the map has to be a gif 87a, non interlaced, 256 colors, 64x64.
'- for bilinear mapping, the palette of the gif has to be grayscale, or linear.
'- real phong shading can't be done much faster than this, cause per pixel you
'  need 4 multiplications, 1 divide and 1 square root.
'- check this out: env19.gif
'                     this map looks amazing on every object on bilinear
'                     filtered enviroment mapping! (ie teapot.plg, duck.plg,
'                     cow.plg)
'                  env20.gif
'                     enviroment mapping looks very realistic on some
'                     obejcts (ie teapot.plg), bilinear doesn't work well on
'                     this map cause not linear pal.
'                  cow.plg and hiteapot.plg
'                     both with polygon counts near 4000! well, pb3d can't
'                     load much more than 4000, cause lack of memory, cause
'                     i needed a screenbuffer, but modex wasn't fast enough,
'                     so i had to store it in dos-memory.
$string 1
$static
DIM scr(32000) AS INTEGER
$dynamic
DECLARE SUB sortit (lo%, hi%)
DECLARE SUB ReadPlgHeader (file$)
DECLARE SUB ReadPlgObject (file$, pnt%, pol%)
declare sub setpal (n%)
DECLARE SUB loadgif(string)
declare sub qline (byval x1%, byval y1%, byval x2%, byval y2%, byval c?)
declare sub antiline (byval x1!, byval y1!, byval x2!, byval y2!)
declare sub putobject (byval wx%, byval wy%, byval wz%, byval xm%, byval ym%, byval ty%)

SHARED objname$, pnt%, pol%, p%, ns?, offs??, col!, ap%, file$, tex%

SCREEN 0: CLS
PRINT "POWER BASIC 3D ENGINE"
PRINT ""
PRINT "Copyright: Marko Dokic 1998"
print "EMail:     marko.d@gmx.net       ICQ: 4944162"
PRINT "Homepage:  http://www.geocities.com/SiliconValley/Network/7147/index.html"
PRINT ""
PRINT "Keys:"
PRINT "q,a  x-rotate        1  dots                     6  real phong shading"
PRINT "w,s  y-rotate        2  wireframe                7  enviroment mapping"
PRINT "e,d  z-rotate        3  antialiased wireframe    8  bilinear env. mapping"
PRINT "x    stop rotation   4  flat shading             9  texture mapping"
PRINT "+,-  zoom            5  gouraud shading          0  bilinear tex. mapping"
print ""

offs?? = VARPTR(scr(1))
p% = VARSEG(scr(1))
DEF SEG = p%

m0 = 1                           'vergrsserung vom objekt
ns?=64                           'size of envmap

input "object (press enter for torus.plg): ",file$
if file$="" then file$="torus.plg"
if instr(file$,".")=0 then file$ = file$ + ".plg"
IF DIR$(file$)="" THEN print"object not found.":end

input "map    (press enter for env09.gif): ",envmap$
if envmap$="" then envmap$="env09.gif"
if instr(envmap$,".")=0 then envmap$ = envmap$ + ".gif"
IF DIR$(envmap$)="" THEN print "envmap not found.": end

dim em(ns?,ns?) as shared byte
dim ep(768) as shared byte
ns?=ns?/2

print "Loading enviroment map..."
loadgif envmap$

PRINT "Loading object...              ";

ReadPlgHeader file$

DIM xb(pnt%) AS shared integer               'screen points
DIM zb(pnt%) AS shared integer               'screen points
DIM ya(pnt%) AS shared integer               'points after rotation
DIM yd(pnt%) AS shared single         'original coordinates of the object
DIM xd(pnt%) AS shared single         'original coordinates of the object
DIM zd(pnt%) AS shared single         'original coordinates of the object
dim pc(pnt%,3) as shared single
DIM iz(pol%) AS shared SINGLE                        'sorting stuff
DIM inr(pol%) AS shared INTEGER                      'sorting stuff
DIM poly(pol%, 3) AS shared INTEGER   'polygon data
DIM pnorm(pnt%, 3) AS shared SINGLE
DIM norm(pol%, 3) AS shared single

PRINT objname$ + "has" + STR$(pnt%) + " points and" + STR$(pol%) + " polygons."

ReadPlgObject file$, pnt%, pol%

PRINT "Precomputing SIN-Tables"
DIM sim(450) AS shared SINGLE
FOR i% = 0 TO 450
sim(i%) = SIN(i% * (3.14159265359# / 180))
NEXT i%

shade%=1
ppo! = TIMER
col! = 255/1.732                   'number of colors / lenght of light-vector

DIM m(10, 10) AS shared SINGLE                             'rotating stuff buffer

PRINT "Loading Done!"
PRINT "Press a key"
DO UNTIL INKEY$ <> "": LOOP

!mov ax,&h13
!int &h10

setpal 1

'main loop
DO
putobject wx%, wy%, wz%, 160, 100, shade%

for i%=320 to 400 step 10: POKE i%, 255: next i%

POKE pt%, 255

! PUSH    DS
! MOV     AX,p%
! MOV     DS,AX
! MOV     SI,0
! MOV     AX,&HA000
! MOV     ES,AX
! MOV     DI,0
! MOV     CX,&H3E80
! db &Hf3
! db &H66       ;rep movsd
! db &Ha5
! POP     DS

DEF SEG = p%

erase scr()

op! = TIMER: IF op! > ppo! + 1 THEN ppo! = op!: pt% = ght%: ght% = 0
ght% = ght% + 1

a$ = UCASE$(inkey$)
SELECT CASE a$
 CASE CHR$(27): EXIT DO
 CASE "Q": mx% = mx% + 1
 CASE "A": mx% = mx% - 1
 CASE "W": my% = my% + 1
 CASE "S": my% = my% - 1
 CASE "E": mz% = mz% + 1
 CASE "D": mz% = mz% - 1
 CASE "X": mx% = 0: my% = 0: mz% = 0
 case "1": shade%=1
 case "2": shade%=2
 case "3": shade%=3
 case "4": shade%=4
 case "5": shade%=5
 case "6": shade%=6
 case "7": shade%=7: tex%=1
 case "8": shade%=8: tex%=1
 case "9"
   shade%=7: tex%=0: FOR i = 1 TO pnt%: pc(i,1)= xd(i)/2+32: pc(i,2)= zd(i)/2+32: NEXT
 case "0"
   shade%=8: tex%=0: FOR i = 1 TO pnt%: pc(i,1)= xd(i)/2+32: pc(i,2)= zd(i)/2+32: NEXT
 CASE "+"
   m1 = m0 + .1
   FOR i = 1 TO pnt%: xd(i) = (xd(i) / m0) * m1: yd(i) = (yd(i) / m0) * m1: zd(i) = (zd(i) / m0) * m1: NEXT
   m0 = m1
 CASE "-"
   m1 = m0 - .1
   FOR i = 1 TO pnt%: xd(i) = (xd(i) / m0) * m1: yd(i) = (yd(i) / m0) * m1: zd(i) = (zd(i) / m0) * m1: NEXT
   m0 = m1
 CASE "O"
   decr ap%
   if ap%=0 then ap%=6
   setpal ap%
 case "P"
   incr ap%
   if ap%=7 then ap%=1
   setpal ap%
END SELECT

wx% = wx% + mx%
wy% = wy% + my%
wz% = wz% + mz%
wx% = wx% MOD 360: IF wx% < 0 THEN wx% = 360 + wx%
wy% = wy% MOD 360: IF wy% < 0 THEN wy% = 360 + wy%
wz% = wz% MOD 360: IF wz% < 0 THEN wz% = 360 + wz%
LOOP

!mov ax,&h3
!int &h10

END

sub putobject (byval wx%, byval wy%, byval wz%, byval x0%, byval y0%, byval shade%) public
defseg=p%

si1! = sim(wx%): cs1! = sim(wx% + 90)
si2! = sim(wy%): cs2! = sim(wy% + 90)
si3! = sim(wz%): cs3! = sim(wz% + 90)

m(1, 1) = cs2! * cs3!
m(1, 2) = cs1! * si3! + si1! * si2! * cs3!
m(1, 3) = si1! * si3! - cs1! * si2! * cs3!
m(2, 1) = -cs2! * si3!
m(2, 2) = cs1! * cs3! - si1! * si2! * si3!
m(2, 3) = si1! * cs3! + cs1! * si2! * si3!
m(3, 1) = si2!
m(3, 2) = -si1! * cs2!
m(3, 3) = cs1! * cs2!

select case shade%
case 1            '***********************  dots  ***********
  if ap% <> 1 then setpal 1: ap%=1
  FOR i% = 1 TO pnt%
    xb(i%) = m(1, 1) * xd(i%) + m(2, 1) * yd(i%) + m(3, 1) * zd(i%) + x0%
    zb(i%) = m(1, 3) * xd(i%) + m(2, 3) * yd(i%) + m(3, 3) * zd(i%) + y0%
  NEXT
  FOR i% = 1 TO pol%
    normy! = m(1, 2) * norm(i%, 1) + m(2, 2) * norm(i%, 2) + m(3, 2) * norm(i%, 3)
    IF normy! >= 0 THEN
      x1%=xb(poly(i%,1)): x2%=xb(poly(i%,2)): x3%=xb(poly(i%,3))
      y1%=zb(poly(i%,1)): y2%=zb(poly(i%,2)): y3%=zb(poly(i%,3))
      if y1%>0 and y1%<200 and x1%>0 and x1%<320 then poke y1%*320+x1%, 254
      if y2%>0 and y2%<200 and x2%>0 and x2%<320 then poke y2%*320+x2%, 254
      if y3%>0 and y3%<200 and x3%>0 and x3%<320 then poke y3%*320+x3%, 254
    end if
  NEXT

case 2            '***********************  wireframe  ***
  if ap% <> 1 then setpal 1: ap%=1
  FOR i% = 1 TO pnt%
   xb(i%) = m(1, 1) * xd(i%) + m(2, 1) * yd(i%) + m(3, 1) * zd(i%) + x0%
   zb(i%) = m(1, 3) * xd(i%) + m(2, 3) * yd(i%) + m(3, 3) * zd(i%) + y0%
  NEXT
  FOR i% = 1 TO pol%
    normy! = m(1, 2) * norm(i%, 1) + m(2, 2) * norm(i%, 2) + m(3, 2) * norm(i%, 3)
    IF normy! >= 0 THEN
      qline xb(poly(i%,1)), zb(poly(i%,1)), xb(poly(i%,2)), zb(poly(i%,2)), 255
      qline xb(poly(i%,2)), zb(poly(i%,2)), xb(poly(i%,3)), zb(poly(i%,3)), 255
      qline xb(poly(i%,3)), zb(poly(i%,3)), xb(poly(i%,1)), zb(poly(i%,1)), 255
    end if
  NEXT i%

case 3            '***********************  wireframe  ***
  if ap% <> 1 then setpal 1: ap%=1
  FOR i% = 1 TO pnt%
   pc(i%,1) = m(1, 1) * xd(i%) + m(2, 1) * yd(i%) + m(3, 1) * zd(i%) + x0%
   pc(i%,2) = m(1, 3) * xd(i%) + m(2, 3) * yd(i%) + m(3, 3) * zd(i%) + y0%
  NEXT
  FOR i% = 1 TO pol%
    normy! = m(1, 2) * norm(i%, 1) + m(2, 2) * norm(i%, 2) + m(3, 2) * norm(i%, 3)
    IF normy! >= 0 THEN
      antiline pc(poly(i%,1),1), pc(poly(i%,1),2) , pc(poly(i%,2),1), pc(poly(i%,2),2)
      antiline pc(poly(i%,2),1), pc(poly(i%,2),2) , pc(poly(i%,3),1), pc(poly(i%,3),2)
      antiline pc(poly(i%,3),1), pc(poly(i%,3),2) , pc(poly(i%,1),1), pc(poly(i%,1),2)
    end if
  NEXT i

case 4            '***********************  Flat shading  *******
  if ap% <> 4 then setpal 4: ap%=4
  dp%=0
  px1!=m(1,1)+m(1,2)+m(1,3)
  py1!=m(2,1)+m(2,2)+m(2,3)
  pz1!=m(3,1)+m(3,2)+m(3,3)
  FOR i% = 1 TO pnt%
    xb(i%) = (m(1, 1) * xd(i%) + m(2, 1) * yd(i%) + m(3, 1) * zd(i%))+x0%
    ya(i%) = (m(1, 2) * xd(i%) + m(2, 2) * yd(i%) + m(3, 2) * zd(i%))
    zb(i%) = (m(1, 3) * xd(i%) + m(2, 3) * yd(i%) + m(3, 3) * zd(i%))+y0%
  NEXT
  FOR i% = 1 TO pol%
    normy! = m(1, 2) * norm(i%, 1) + m(2, 2) * norm(i%, 2) + m(3, 2) * norm(i%, 3)
    IF normy! >= 0 THEN incr dp%: inr(dp%) = i%: iz(dp%) = (ya(poly(i%, 1)) + ya(poly(i%, 2)) + ya(poly(i%, 3))) / 3
  NEXT
  sortit 1, dp%
  FOR i% = dp% TO 1 STEP -1
    j% = inr(i%)
    normy! = px1! * norm(j%,1) + py1! * norm(j%,2) + pz1! * norm(j%,3)
    IF normy! < 0 THEN cn?=0 else cn?=int(normy!*col!)

    IF zb(poly(j%, 1)) > zb(poly(j%, 2)) THEN s1? = 2: s2? = 1 ELSE s1? = 1: s2? = 2
    IF zb(poly(j%, s2?)) < zb(poly(j%, 3)) THEN s2? = 3 ELSE IF zb(poly(j%, s1?)) > zb(poly(j%, 3)) THEN s1? = 3
    p1% = poly(j%, s1?): y1% = zb(p1%): p2% = poly(j%, s2?): y2% = zb(p2%)

      IF y2% <> y1% AND y1% > 0 AND y2% < 200 THEN
        ! xor  ax, ax
        ! add  ax, s1?
        ! add  ax, s2?
        ! mov  s3?, 6
        ! sub  s3?, ax

        p3% = poly(j%, s3?): y3% = zb(p3%)
        x1% = xb(p1%): x2% = xb(p2%): x3% = xb(p3%)

        ! mov ah,y1%
        ! xor al,al
        ! mov bx,offs??
        ! add bx,ax
        ! shr ax,1
        ! shr ax,1
        ! add bx,ax
        ! mov os??,bx

      te! = (y3% - y1%) / (y2% - y1%)
      wid! = (x1% - x3%) + te! * (x2% - x1%)

      if wid!>0 then
        x! = os??+x1%: ds! = (x2%-x1%) / (y2%-y1%) + 320
      else
        x2! = os??+x1%: ds2! = (x2%-x1%) / (y2%-y1%) + 320
      end if

      IF y3% <> y1% THEN
        yu% = y3% - y1%
        if wid!>0 then
          x2! = os??+x1%: ds2! = (x3%-x1%) / (y3%-y1%) + 320
        else
          x! = os??+x1%: ds! = (x3%-x1%) / (y3%-y1%) + 320
        end if
        FOR y% = y1% TO y3%-1
          sx1??=int(x2!)
          sx2??=int(x!)
          ! push es
          ! mov  ax, p%
          ! mov  es, ax
          ! mov  bx, sx1??
          ! mov  al, cn?
          ! mov  dx, sx2??
          again:
          ! mov  es:[bx], al
          ! inc  bx
          ! cmp  bx, dx
          ! jb again
          ! pop es
          incr x!, ds!: incr x2!, ds2!: incr os??, 320
        NEXT y%
      END IF

      IF y2% <> y3% THEN
        if wid!>0 then
          x2! = os??+x3%: ds2! = (x2%-x3%)/(y2%-y3%)+320
        else
          x! = os??+x3%: ds! = (x2%-x3%)/(y2%-y3%)+ 320
        end if
        FOR y% = y3% TO y2%
          sx1??=int(x2!)
          sx2??=int(x!)
          ! push es
          ! mov  ax, p%
          ! mov  es, ax
          ! mov  bx, sx1??
          ! mov  al, cn?
          ! mov  dx, sx2??
          again2:
          ! mov  es:[bx], al
          ! inc  bx
          ! cmp  bx, dx
          ! jb again2
          ! pop es
          incr x!, ds!: incr x2!, ds2!
        NEXT y%
      END IF
    END IF
  NEXT i

case 5            '***********************  gouraud shading  *****
  if ap% <> 4 then setpal 4: ap%=4
  px1!=(m(1,1)+m(1,2)+m(1,3))*128
  py1!=(m(2,1)+m(2,2)+m(2,3))*128
  pz1!=(m(3,1)+m(3,2)+m(3,3))*128
  FOR i% = 1 TO pnt%
    xb(i%) = (m(1, 1) * xd(i%) + m(2, 1) * yd(i%) + m(3, 1) * zd(i%))+x0%
    ya(i%) = m(1, 2) * xd(i%) + m(2, 2) * yd(i%) + m(3, 2) * zd(i%)
    zb(i%) = (m(1, 3) * xd(i%) + m(2, 3) * yd(i%) + m(3, 3) * zd(i%))+y0%
    normx! = px1! * pnorm(i%, 1) + py1! * pnorm(i%, 2) + pz1! * pnorm(i%, 3)
    IF normx! < 0 THEN pc(i%,1) = 0 else pc(i%,1)=normx!*col!
  NEXT
  dp%=0
  FOR i% = 1 TO pol%
    normx! = m(1, 2) * norm(i%, 1) + m(2, 2) * norm(i%, 2) + m(3, 2) * norm(i%, 3)
    IF normx! >= 0 THEN incr dp%: inr(dp%) = i%: iz(dp%) = (ya(poly(i%, 1)) + ya(poly(i%, 2)) + ya(poly(i%, 3))) / 3
  NEXT

  sortit 1, dp%

  FOR i% = dp% TO 1 STEP -1
    j% = inr(i%)
    IF zb(poly(j%, 1)) > zb(poly(j%, 2)) THEN s1? = 2: s2? = 1 ELSE s1? = 1: s2? = 2
    IF zb(poly(j%, s2?)) < zb(poly(j%, 3)) THEN s2? = 3 ELSE IF zb(poly(j%, s1?)) > zb(poly(j%, 3)) THEN s1? = 3
    p1% = poly(j%, s1?): y1% = zb(p1%): p2% = poly(j%, s2?): y2% = zb(p2%)

    IF y2% <> y1% AND y1% > 0 AND y2% < 200 THEN
      ! xor  ax, ax
      ! add  ax, s1?
      ! add  ax, s2?
      ! mov  s3?, 6
      ! sub  s3?, ax

      os?? = y1% * 320 + offs??: p3% = poly(j%, s3?): y3% = zb(p3%)
      x1% = xb(p1%): x2% = xb(p2%): x3% = xb(p3%): c1! = pc(p1%,1): c2! = pc(p2%,1): c3! = pc(p3%,1)

      te! = (y3% - y1%) / (y2% - y1%)
      wid! = (x1% - x3%) + te! * (x2% - x1%)
      IF wid! <> 0 THEN csl% = int(  (te! * (c2! - c1!) + (c1! - c3!)) / wid!)

      yu% = y2% - y1%
      if wid!>0 then
        x! = os??+x1%: ds! = (x2%-x1%) / yu% + 320
      else
        x2! = os??+x1%: ds2! = (x2%-x1%) / yu% + 320: cl2! = c1!: cs2! = (c2! -c1!)/ yu%
      end if

      IF y3% <> y1% THEN
        yu% = y3% - y1%
        if wid!>0 then
          x2! = os??+x1%: ds2! = (x3%-x1%) / yu% + 320: cl2! = c1!: cs2! = (c3!-c1!) / yu%
        else
          x! = os??+x1%: ds! = (x3%-x1%) / yu% + 320
        end if
        FOR y% = y1% TO y3%-1
          co1%=int(cl2!)
          FOR k?? = int(x2!) TO int(x!)-1
            POKE k??, co1%\128
            incr co1%, csl%
          NEXT k??
          incr os??, 320: incr x!, ds!: incr x2!, ds2!: incr cl2!, cs2!
        NEXT y%
      END IF

      IF y2% <> y3% THEN
        yu% = y2% - y3%
        if wid!>0 then
          x2! = os??+x3%: cl2! = c3!: ds2! = (x2%-x3%) / yu% + 320: cs2! = (c2!-c3!) / yu%
        else
          x! = os??+x3%: ds! = (x2%-x3%) / yu% + 320
        end if
        FOR y% = y3% TO y2%
          co1% = int(cl2!)
          FOR k?? = int(x2!) TO int(x!)-1
            POKE k??, co1%\128
            incr co1%, csl%
          NEXT k??
          incr x!, ds!: incr x2!, ds2!: incr cl2!, cs2!
        NEXT y%
      END IF
    END IF
  NEXT i

case 6            '***********************  REAL phong shading  ****
  if ap% <> 4 then setpal 4: ap%=4
  FOR i% = 1 TO pnt%
    xb(i%) = m(1, 1) * xd(i%) + m(2, 1) * yd(i%) + m(3, 1) * zd(i%) + x0%
    ya(i%) = m(1, 2) * xd(i%) + m(2, 2) * yd(i%) + m(3, 2) * zd(i%)
    zb(i%) = m(1, 3) * xd(i%) + m(2, 3) * yd(i%) + m(3, 3) * zd(i%) + y0%
    pc(i%,1) = m(1, 1) * pnorm(i%, 1) + m(2, 1) * pnorm(i%, 2) + m(3, 1) * pnorm(i%, 3)
    pc(i%,2) = m(1, 2) * pnorm(i%, 1) + m(2, 2) * pnorm(i%, 2) + m(3, 2) * pnorm(i%, 3)
    pc(i%,3) = m(1, 3) * pnorm(i%, 1) + m(2, 3) * pnorm(i%, 2) + m(3, 3) * pnorm(i%, 3)
  NEXT

  dp%=0
  FOR i% = 1 TO pol%
    normy! = m(1, 2) * norm(i%, 1) + m(2, 2) * norm(i%, 2) + m(3, 2) * norm(i%, 3)
    IF normy! >= 0 THEN incr dp%: inr(dp%) = i%: iz(dp%) = (ya(poly(i%, 1)) + ya(poly(i%, 2)) + ya(poly(i%, 3))) / 3
  NEXT

  sortit 1, dp%

  FOR i% = dp% TO 1 STEP -1
    j% = inr(i%)
    IF zb(poly(j%, 1)) > zb(poly(j%, 2)) THEN s1? = 2: s2? = 1 ELSE s1? = 1: s2? = 2
    IF zb(poly(j%, s2?)) < zb(poly(j%, 3)) THEN s2? = 3 ELSE IF zb(poly(j%, s1?)) > zb(poly(j%, 3)) THEN s1? = 3

    s3? = 6 - (s1? + s2?)

    p1% = poly(j%, s1?): y1% = zb(p1%): x1% = xb(p1%)
    p2% = poly(j%, s2?): y2% = zb(p2%): x2% = xb(p2%)
    p3% = poly(j%, s3?): y3% = zb(p3%): x3% = xb(p3%)

    te! = (y3% - y1%) / (y2% - y1%)
    wid! = (x1% - x3%) + te! * (x2% - x1%)

    IF y2% <> y1% AND y1% > 0 AND y2% < 200 AND wid! <> 0 THEN
      ! mov ah,y1%
      ! xor al,al
      ! mov bx,offs??
      ! add bx,ax
      ! shr ax,1
      ! shr ax,1
      ! add bx,ax
      ! mov os??,bx

      px1! = pc(p1%,1): py1! = pc(p1%,2): pz1! = pc(p1%,3)
      px2! = pc(p2%,1): py2! = pc(p2%,2): pz2! = pc(p2%,3)
      px3! = pc(p3%,1): py3! = pc(p3%,2): pz3! = pc(p3%,3)

      cxs! = ((te! * (px2! - px1!)) + (px1! - px3!)) / wid!
      cys! = ((te! * (py2! - py1!)) + (py1! - py3!)) / wid!
      czs! = ((te! * (pz2! - pz1!)) + (pz1! - pz3!)) / wid!

      yu% = y2% - y1%
      if wid!>0 then
        x! = x1% + os??: ds! = (x2%-x1%) / yu% + 320
      else
        x2s! = x1% + os??: d2s! = (x2%-x1%) / yu% + 320
        pxl! = px1!: pxs! = (px2!-px1!) / yu%: pyl! = py1!: pys! = (py2!-py1!) / yu%: pzl! = pz1!: pzs! = (pz2!-pz1!) / yu%
      end if

      IF y3% <> y1% THEN
        yu% = y3% - y1%
        if wid!>0 then
          x2s! = x1% + os??: d2s! = (x3%-x1%) / yu% + 320
          pxl! = px1!: pxs! = (px3!-px1!) / yu%: pyl! = py1!: pys! = (py3!-py1!) / yu%: pzl! = pz1!: pzs! = (pz3!-pz1!) / yu%
        else
          x! = os?? + x1%: ds! = (x3%-x1%) / yu% + 320
        end if
        FOR y% = y1% TO y3%-1
          cx1! = pxl!: cy1! = pyl!: cz1! = pzl!
          FOR k?? = int(x2s!) TO int(x!)-1
            cl% = int((cx1! + cy1! + cz1!) * col! / SQR(cx1! * cx1! + cy1! * cy1! + cz1! * cz1!))
            IF cl% < 0 THEN cl%=0
            POKE k??, cl%
            incr cx1!, cxs!: incr cy1!, cys!: incr cz1!, czs!
          NEXT k??
          incr os??, 320: incr x!, ds!: incr x2s!, d2s!
          incr pxl!, pxs!: incr pyl!, pys!: incr pzl!, pzs!
        NEXT y%
      END IF

      IF y2% <> y3% THEN
        yu% = y2% - y3%
        if wid!>0 then
          x2s! = x3% + os??: d2s! = (x2%-x3%) / yu% + 320
          pxl! = px3!: pxs! = (px2!-px3!) / yu%: pyl! = py3!: pys! = (py2!-py3!) / yu%: pzl! = pz3!: pzs! = (pz2!-pz3!) / yu%
        else
          x! = os?? + x3%: ds! = (x2%-x3%) / yu% + 320
        end if
        FOR y% = y3% TO y2%-1
          cx1! = pxl!: cy1! = pyl!: cz1! = pzl!
          FOR k?? = int(x2s!) TO int(x!)-1
            cl% = int((cx1! + cy1! + cz1!) * col! / SQR(cx1! * cx1! + cy1! * cy1! + cz1! * cz1!))
            IF cl% < 0 THEN cl%=0
            POKE k??, cl%
            incr cx1!, cxs!: incr cy1!, cys!: incr cz1!, czs!
          NEXT k??
          incr x!, ds!: incr x2s!, d2s!
          incr pxl!, pxs!: incr pyl!, pys!: incr pzl!, pzs!
        NEXT y%
      END IF
    END IF
  NEXT i

case 7                    '* texture / enviroment mapping  *****
  if ap% <> 5 then setpal 5: ap%=5
  FOR i% = 1 TO pnt%
    xb(i%) = (m(1, 1) * xd(i%) + m(2, 1) * yd(i%) + m(3, 1) * zd(i%))+x0%
    ya(i%) = m(1, 2) * xd(i%) + m(2, 2) * yd(i%) + m(3, 2) * zd(i%)
    zb(i%) = (m(1, 3) * xd(i%) + m(2, 3) * yd(i%) + m(3, 3) * zd(i%))+y0%
  next i%

  if tex%=1 then
    for i% = 1 to pnt%
      normx! = m(1, 1) * pnorm(i%, 1) + m(2, 1) * pnorm(i%, 2) + m(3, 1) * pnorm(i%, 3)
      normz! = m(1, 3) * pnorm(i%, 1) + m(2, 3) * pnorm(i%, 2) + m(3, 3) * pnorm(i%, 3)
      pc(i%,1)= normx!*ns?+ns?
      pc(i%,2)= normz!*ns?+ns?
    NEXT i%
  end if

  dp%=0
  FOR i% = 1 TO pol%
    normx! = m(1, 2) * norm(i%, 1) + m(2, 2) * norm(i%, 2) + m(3, 2) * norm(i%, 3)
    IF normx! >= 0 THEN incr dp%: inr(dp%) = i%: iz(dp%) = (ya(poly(i%, 1)) + ya(poly(i%, 2)) + ya(poly(i%, 3))) / 3
  NEXT

  sortit 1, dp%

  FOR i% = dp% TO 1 STEP -1
    j% = inr(i%)
    IF zb(poly(j%, 1)) > zb(poly(j%, 2)) THEN s1? = 2: s2? = 1 ELSE s1? = 1: s2? = 2
    IF zb(poly(j%, s2?)) < zb(poly(j%, 3)) THEN s2? = 3 ELSE IF zb(poly(j%, s1?)) > zb(poly(j%, 3)) THEN s1? = 3
    p1% = poly(j%, s1?): y1% = zb(p1%): p2% = poly(j%, s2?): y2% = zb(p2%)

    IF y2% <> y1% AND y1% > 0 AND y2% < 200 THEN
      ! xor  ax, ax
      ! add  ax, s1?
      ! add  ax, s2?
      ! mov  s3?, 6
      ! sub  s3?, ax

      os?? = y1% * 320 + offs??: p3% = poly(j%, s3?): y3% = zb(p3%)
      x1% = xb(p1%): x2% = xb(p2%): x3% = xb(p3%)
      px1!=pc(p1%,1): py1!=pc(p1%,2): px2!=pc(p2%,1): py2!=pc(p2%,2): px3!=pc(p3%,1): py3!=pc(p3%,2)

      te! = (y3% - y1%) / (y2% - y1%)
      wid! =(x1% - x3%) + te! * (x2% - x1%)
      IF wid! <> 0 THEN
        cxs! = ((te! * (px2! - px1!)) + (px1! - px3!)) / wid!
        cys! = ((te! * (py2! - py1!)) + (py1! - py3!)) / wid!
      end if

      yu% = y2% - y1%
      if wid!>0 then
        x! = os??+x1% : ds! = (x2%-x1%) / yu% + 320
      else
        x2! = os??+x1% : ds2! = (x2%-x1%) / yu% +320: pxl!=px1!: pyl!=py1!: pxs! = (px2!-px1!) / yu%: pys! = (py2!-py1!) / yu%
      end if

      IF y3% <> y1% THEN
        yu% = y3% - y1%
        if wid!>0 then
          x2! = os??+x1%: ds2! = (x3%-x1%) / yu% + 320: pxl!=px1!: pyl!=py1!: pxs! = (px3!-px1!) / yu%: pys! = (py3!-py1!) / yu%
        else
          x! = os??+x1%: ds! = (x3%-x1%) / yu% + 320
        end if
        FOR y% = y1% TO y3%-1
          cx1! = pxl!: cy1! = pyl!
          FOR k?? = int(x2!) TO int(x!) - 1
            POKE k??, em(int(cx1!),int(cy1!))
            incr cx1!, cxs!: incr cy1!, cys!
          NEXT k??
          incr os??, 320: incr x!, ds!: incr x2!, ds2: incr pxl!, pxs!: incr pyl!, pys!
        NEXT y%
      END IF

      IF y2% <> y3% THEN
        yu% = y2% - y3%
        if wid!>0 then
          x2! = os??+x3%: ds2! = (x2%-x3%) / yu% + 320: pxl!=px3!: pyl!=py3!: pxs! = (px2!-px3!) / yu%: pys! = (py2!-py3!) / yu%
        else
          x! = os??+x3%: ds! = (x2%-x3%) / yu% + 320
        end if
        FOR y% = y3% TO y2%-1
          cx1! = pxl!: cy1! = pyl!
          FOR k?? = int(x2!) TO int(x!) - 1
            POKE k??, em(int(cx1!),int(cy1!))
            incr cx1!, cxs!: incr cy1!, cys!
          NEXT k??
          incr x!, ds!: incr x2!, ds2!: incr pxl!, pxs!: incr pyl!, pys!
        NEXT y%
      END IF
    END IF
  NEXT i%

case 8                   '* texture / enviroment mapping (bilinear) *****
  if ap% <> 5 then setpal 5: ap%=5
  FOR i% = 1 TO pnt%
    xb(i%) = m(1, 1) * xd(i%) + m(2, 1) * yd(i%) + m(3, 1) * zd(i%)+x0%
    ya(i%) = m(1, 2) * xd(i%) + m(2, 2) * yd(i%) + m(3, 2) * zd(i%)
    zb(i%) = m(1, 3) * xd(i%) + m(2, 3) * yd(i%) + m(3, 3) * zd(i%)+y0%
  NEXT

  if tex%=1 then
    for i% = 1 to pnt%
      normx! = m(1, 1) * pnorm(i%, 1) + m(2, 1) * pnorm(i%, 2) + m(3, 1) * pnorm(i%, 3)
      normz! = m(1, 3) * pnorm(i%, 1) + m(2, 3) * pnorm(i%, 2) + m(3, 3) * pnorm(i%, 3)
      pc(i%,1)= normx!*ns?+ns?
      pc(i%,2)= normz!*ns?+ns?
    NEXT
  end if

  dp%=0
  FOR i% = 1 TO pol%
    normx! = m(1, 2) * norm(i%, 1) + m(2, 2) * norm(i%, 2) + m(3, 2) * norm(i%, 3)
    IF normx! >= 0 THEN incr dp%: inr(dp%) = i%: iz(dp%) = (ya(poly(i%, 1)) + ya(poly(i%, 2)) + ya(poly(i%, 3))) / 3
  NEXT

  sortit 1, dp%

  FOR i% = dp% TO 1 STEP -1
    j% = inr(i%)
    IF zb(poly(j%, 1)) > zb(poly(j%, 2)) THEN s1? = 2: s2? = 1 ELSE s1? = 1: s2? = 2
    IF zb(poly(j%, s2?)) < zb(poly(j%, 3)) THEN s2? = 3 ELSE IF zb(poly(j%, s1?)) > zb(poly(j%, 3)) THEN s1? = 3
    p1% = poly(j%, s1?): y1% = zb(p1%): p2% = poly(j%, s2?): y2% = zb(p2%)

    IF y2% <> y1% AND y1% > 0 AND y2% < 200 THEN
      ! xor  ax, ax
      ! add  ax, s1?
      ! add  ax, s2?
      ! mov  s3?, 6
      ! sub  s3?, ax

      os?? = y1% * 320 + offs??: p3% = poly(j%, s3?): y3% = zb(p3%)
      x1% = xb(p1%): x2% = xb(p2%): x3% = xb(p3%)
      px1!=pc(p1%,1): py1!=pc(p1%,2): px2!=pc(p2%,1): py2!=pc(p2%,2): px3!=pc(p3%,1): py3!=pc(p3%,2)
      te! = (y3% - y1%) / (y2% - y1%)
      wid! =(x1% - x3%) + te! * (x2% - x1%)
      IF wid! <> 0 THEN
        cxs! = ((te! * (px2! - px1!)) + (px1! - px3!)) / wid!
        cys! = ((te! * (py2! - py1!)) + (py1! - py3!)) / wid!
      end if

      yu% = y2% - y1%
      if wid!>0 then
        x! = os??+x1% : ds! = (x2%-x1%) / yu% + 320
      else
        x2! = os??+x1% : ds2! = (x2%-x1%) / yu% +320: pxl!=px1!: pyl!=py1!: pxs! = (px2!-px1!) / yu%: pys! = (py2!-py1!) / yu%
      end if

      IF y3% <> y1% THEN
        yu% = y3% - y1%
        if wid!>0 then
          x2! = os??+x1%: ds2! = (x3%-x1%) / yu% + 320: pxl!=px1!: pyl!=py1!: pxs! = (px3!-px1!) / yu%: pys! = (py3!-py1!) / yu%
        else
          x! = os??+x1%: ds! = (x3%-x1%) / yu% + 320
        end if
        FOR y% = y1% TO y3%-1
          cx1! = pxl!: cy1! = pyl!
          FOR k?? = int(x2!) TO int(x!) - 1
            x?=int(cx1!)
            y?=int(cy1!)
            dx! = cx1!-x?: dy! = cy1!-y?: omdx! = 1-dx!: omdy! = 1-dy!
            c? = int(omdx!*omdy!*em(x?,y?) + omdx!*dy!*em(x?,y?+1) + dx!*omdy!*em(x?+1,y?) + dx!*dy!*em(x?+1,y?+1))
            POKE k??, c?
            incr cx1!, cxs!: incr cy1!, cys!
          NEXT k??
          incr os??, 320: incr x!, ds!: incr x2!, ds2: incr pxl!, pxs!: incr pyl!, pys!
        NEXT y%
      END IF

      IF y2% <> y3% THEN
        yu% = y2% - y3%
        if wid!>0 then
          x2! = os??+x3%: ds2! = (x2%-x3%) / yu% + 320: pxl!=px3!: pyl!=py3!: pxs! = (px2!-px3!) / yu%: pys! = (py2!-py3!) / yu%
        else
          x! = os??+x3%: ds! = (x2%-x3%) / yu% + 320
        end if
        FOR y% = y3% TO y2%-1
          cx1! = pxl!: cy1! = pyl!
          FOR k?? = int(x2!) TO int(x!) - 1
            x?=int(cx1!)
            y?=int(cy1!)
            dx! = cx1!-x?: dy! = cy1!-y?: omdx! = 1-dx!: omdy! = 1-dy!
            c? = int(omdx!*omdy!*em(x?,y?) + omdx!*dy!*em(x?,y?+1) + dx!*omdy!*em(x?+1,y?) + dx!*dy!*em(x?+1,y?+1))
            POKE k??, c?
            incr cx1!, cxs!: incr cy1!, cys!
          NEXT k??
          incr x!, ds!: incr x2!, ds2!: incr pxl!, pxs!: incr pyl!, pys!
        NEXT y%
      END IF
    END IF
  NEXT i%

end select
end sub

SUB sortit (lo%, hi%) public
  i% = lo%: j% = hi%
  t%=hi%+lo%: shift right t%,1: mid! = iz(t%)
  DO UNTIL i% > j%
    DO WHILE iz(i%) < mid!: incr i%: LOOP
    DO WHILE mid! < iz(j%): decr j%: LOOP
    IF i% <= j% THEN SWAP inr(i%), inr(j%): SWAP iz(i%), iz(j%): incr i%: decr j%
  LOOP
  IF lo% < j% THEN sortit lo%, j%
  IF i% < hi% THEN sortit i%, hi%
END SUB

SUB setpal (n%)
SELECT CASE n%
 CASE 1
   FOR i% = 0 TO 255: c?=i%*(63/255): OUT &H3C8, i%: OUT &H3C9, c?: OUT &H3C9, c?: OUT &H3C9, c?:next
 CASE 2
   FOR i% = 0 TO 225: c=i%*(63/225):OUT &H3C8, i%: OUT &H3C9,c?: OUT &H3C9, 0: OUT &H3C9, c?:NEXT
   FOR i% = 225 TO 245: c=(63/20)*(i%-225):OUT &H3C8, i%: OUT &H3C9, 63: OUT &H3C9, c?: OUT &H3C9, 63:NEXT
   FOR i% = 245 TO 255: OUT &H3C8, i%: OUT &H3C9, 63: OUT &H3C9, 63: OUT &H3C9, 63:NEXT
 CASE 3
   FOR i% = 0 TO 225: c?=i%*(63/225):OUT &H3C8, i%: OUT &H3C9,c?: OUT &H3C9, 0: OUT &H3C9, 0:NEXT
   FOR i% = 225 TO 245: c?=(63/20)*(i%-225):OUT &H3C8, i%: OUT &H3C9, 63: OUT &H3C9, c?: OUT &H3C9, c?:NEXT
   FOR i% = 245 TO 255:OUT &H3C8, i%: OUT &H3C9, 63: OUT &H3C9, 63: OUT &H3C9, 63:NEXT
 CASE 4
   FOR i% = 0 TO 230: c?=i%*(63/230):OUT &H3C8, i%: OUT &H3C9, c?: OUT &H3C9, 0: OUT &H3C9, c?:NEXT
   FOR i% = 230 TO 250: c?=(63/20)*(i%-230):OUT &H3C8, i%: OUT &H3C9, 63: OUT &H3C9, c?: OUT &H3C9, 63:NEXT
   FOR i% = 250 TO 255:OUT &H3C8, i%: OUT &H3C9, 63: OUT &H3C9, 63: OUT &H3C9, 63:NEXT
 CASE 5
   OUT &H3C7, 0
   OUT &H3C8, 0
   FOR i% = 1 TO 768
     OUT &H3C9, ep(i%)
   NEXT i%
 CASE 6
   maxangle%=256
   facered%=40
   facegreen%=20
   faceblue%=17
   light%=40
   reflect%=150
   ambient%=0
   for i=0 to 255
     OUT &H3C8, i
     intensity# = cos ( (255-i) / 512.0 * 3.14 )
     temp% = int((facered% * ambient% / 63.0) + (facered% * intensity#) + (intensity#^reflect% * light%))
     if temp% > 63 then temp% = 63
     OUT &H3C9,temp%
     temp% = int((facegreen% * ambient% / 63.0) + (facegreen% * intensity#) + (intensity#^reflect% * light%))
     if temp% > 63 then temp% = 63
     OUT &H3C9,temp%
     temp% = int((faceblue% * ambient% / 63.0) + (faceblue% * intensity#) + (intensity#^reflect% * light%))
     if temp% > 63 then temp% = 63
     OUT &H3C9,temp%
   next i
END SELECT
end sub

sub qline (byval x1%, byval y1%, byval x2%, byval y2%, byval c?) public
IF x1% < 0 or x1% > 319 or y1% < 0 or y1% > 199 or x2% < 0 or x2% > 319 or y2% < 0 or y2% > 199 THEN exit sub
local xh??,yh??,sx1??,sx2??

if y1%>y2% then swap x1%,x2%: swap y1%,y2%

! push es
! mov  ax, p%
! mov  es, ax

! mov ah,y1%
! xor al,al
! mov bx,x1%
! add bx,ax
! db &HC1
! db &HE8
! db &H02
! add bx,ax
! mov sx1??,bx         ;y1l??=y1%*320+x1%

! mov ah,y2%
! xor al,al
! mov bx,x2%
! add bx,ax
! db &HC1
! db &HE8
! db &H02
! add bx,ax
! mov sx2??,bx          ;y2l??=y2%*320+x2%

! mov ax, x2%
! mov dx,1
! sub ax, x1%
! jns xdpos
! mov dx,-1
! neg ax
xdpos:
! mov xh??, ax    ;weg machen

! mov bx, y2%
! sub bx, y1%
! mov yh??, bx   ; weg machen

! cmp ax, bx       ;IF xu?? > yu?? THEN
! jbe xubyu

    ! mov cx, xh??            ;yer??=xu??
    ! shr cx,1                 ;shift right yer??,1
    ! mov al, c?
    ! mov bx, sx1??
repline1:
    ! mov es:[bx], al          ;POKE y1l??, 255
    ! add cx, yh??             ;yer?? = yer?? + yu??
    ! add bx, dx               ;y1l??=y1l??+xs%
    ! cmp cx, xh??             ;IF yer?? > xu?? THEN y1l?? = y1l?? + 320: yer?? = yer?? - xu??
    ! jb notyer1
    ! add bx, 320
    ! sub cx, xh??
notyer1:
    ! cmp bx, sx2??
    ! jne repline1

    ! jmp done1

xubyu:

    ! mov cx, yh??
    ! shr cx,1
    ! mov al, c?
    ! mov bx, sx1??
repline2:
    ! mov es:[bx], al
    ! add cx, xh??
    ! add bx, 320
    ! cmp cx, yh??
    ! jb notyer2
    ! add bx, dx
    ! sub cx, yh??
notyer2:
    ! cmp bx, sx2??
    ! jbe repline2
done1:
    ! pop es
end sub

sub antiline (byval x1!, byval y1!, byval x2!, byval y2!)
IF x1! < 1 or x1! > 318 or y1! < 1 or y1! > 198 or x2! < 1 or x2! > 318 or y2! < 1 or y2! > 198 THEN exit sub

xu! = x2! - x1!: yu! = y2! - y1!
IF ABS(xu!) > ABS(yu!) and x1!<>x2! THEN
  d! = yu! / xu!: IF x1! > x2! THEN SWAP x1!, x2!: y! = y2! ELSE y! = y1!

  rd??=frac(d!)*255
  fy?=fix(y!)
  ry?=frac(y!)*255
  xs??=x1!
  xl??=x2!

  ! push es
  ! mov  ax, p%
  ! mov  es, ax
  ! mov  dl, ry?
  ! mov  dh, fy?

  linieg:
  ! mov  ah,dh
  ! xor  al,al
  ! mov  bx,xs??
  ! add  bx,ax
  ! db &HC1
  ! db &HE8
  ! db &H02
  ! add  bx,ax

  ! mov  cl, dl
  ! xor  ch,ch
  ! xor  cl,255
  ! mov  al, es:[bx]
  ! xor  ah,ah
  ! add  ax, cx
  ! shr  ax, 1
  ! mov  es:[bx], al

  ! add  bx,320                ;point2
  ! mov  al, es:[bx]
  ! xor  cl, 255
  ! add  ax, cx
  ! shr  ax, 1
  ! mov  es:[bx], al

  ! add  dx,rd??
  ! mov  ax,xs??   ;
  ! inc  ax        ;  xs?? = xs?? + 1
  ! mov  xs??, ax  ;
  ! cmp  ax, xl??
  ! jbe  linieg

  ! pop  es

ELSE
  d! = xu! / yu!: IF y1! > y2! THEN SWAP y1!, y2!: x! = x2! ELSE x! = x1!

'  dl??=fix(d!*65536)
'  dh??=319

  FOR ys? = y1! TO y2!
    pa??=fix(x!)
    c1??=frac(x!)*255

    ! push es
    ! mov  ax, p%
    ! mov  es, ax

    ! mov ah,ys?
    ! xor al,al
    ! mov bx,pa??
    ! add bx,ax
    ! db &HC1
    ! db &HE8
    ! db &H02
    ! add bx,ax

    ! mov  dx, c1??
    ! mov  al, es:[bx]
    ! xor  ah,ah
    ! xor  dl, 255
    ! add  ax, dx
    ! shr  ax, 1
    ! mov  es:[bx], al

    ! inc  bx                ;point2
    ! mov  al, es:[bx]
    ! xor  dl, 255
    ! add  ax, dx
    ! shr  ax, 1
    ! mov  es:[bx], al

    ! pop  es
    incr x!, d!
  NEXT ys?
END IF
end sub

SUB loadgif(A$) LOCAL PUBLIC
'Translated to PB3 by Thaddy de Koning.
'By Rich Geldreich 1992 (Public domain, use as you wish.)
'edited by marko dokic, removed some unused features to keep small
DIM Prefix(4095), Suffix(4095), OutStack(4095) as integer
OPEN A$ FOR BINARY AS #1: GET$ #1,6, A$
IF A$ <> "GIF87a" THEN PRINT "Not a GIF87a file.": END
GET #1, , TotalX%: GET #1, , TotalY%: GOSUB GetByte: GOSUB GetByte
Background% = a%: GOSUB GetByte: P$ = SPACE$(256 * 3): GET #1, , P$: DO
GOSUB GetByte: IF a% = 44 THEN EXIT DO: GOSUB GetByte: DO: GOSUB GetByte
GET$ #1,a% , A$: LOOP UNTIL a% = 0: LOOP: GET #1, , XStart%: GET #1, , YStart%
GET #1, , XLength%: GET #1, , YLength%: XEnd% = XStart% + XLength%
YEnd% = YStart% + YLength%: GOSUB GetByte: GOSUB GetByte: ClearCode% = 2^a%
EOSCode% = ClearCode% + 1: FirstCode% = ClearCode% + 2: NextCode% = FirstCode%
StartCodeSize% = a% + 1: CodeSize% = StartCodeSize%
StartMaxCode% = 2 ^ (a% + 1) - 1: MaxCode% = StartMaxCode%: BitsIn% = 0
BlockSize% = 0: BlockPointer% = 1: X% = XStart%: Y% = YStart%: Ybase?? = Y% * 320
FOR A% = 1 TO 256 * 3: ep(a%)=ASC(MID$(P$, A%, 1)) \ 4: NEXT
DO: GOSUB GetCode: IF Code% <> EOSCode% THEN
IF Code% = ClearCode% THEN
NextCode% = FirstCode%: CodeSize% = StartCodeSize%
MaxCode% = StartMaxCode%: GOSUB GetCode
CurCode% = Code%: LastCode% = Code%: LastPixel% = Code%
em(x%,y%)=lastpixel%: INCR X%: IF X% = xend% THEN GOSUB NextScanLine
ELSE
CurCode% = Code%: StackPointer% = 0: IF Code% > NextCode% THEN exit do
IF Code% = NextCode% THEN CurCode% = LastCode%: OutStack(StackPointer%) = LastPixel%: INCR StackPointer%
DO WHILE CurCode% >= FirstCode%: OutStack(StackPointer%) = Suffix(CurCode%)
INCR StackPointer%: CurCode% = Prefix(CurCode%): LOOP: LastPixel% = CurCode%
em(x%,y%)=lastpixel%: INCR X%: IF X% = xend% THEN GOSUB NextScanLine
FOR A% = StackPointer% - 1 TO 0 STEP -1: em(x%,y%)=outstack(a%): INCR X%
IF X% = xend% THEN GOSUB NextScanLine
NEXT: IF NextCode% < 4096 THEN
Prefix(NextCode%) = LastCode%: Suffix(NextCode%) = LastPixel%: INCR NextCode%
IF NextCode% > MaxCode% AND CodeSize% < 12 THEN
INCR CodeSize%: MAXCODE%=maxcode%*2: INCR MAXCODE%
END IF: END IF: LastCode% = Code%: END IF: END IF
LOOP UNTIL DoneFlag% OR Code% = EOSCode%
close
EXIT SUB

GetByte:
GET #1,, a?: a%=a?: RETURN
NextScanLine:
INCR Y%: X% = XStart%: Ybase?? = Y% * 320: RETURN
GetCode:
IF BitsIn% = 0 THEN GOSUB ReadBufferedByte: LastChar% = A%: BitsIn% = 8
WorkCode%=LastChar%: shift right workcode%,8-bitsin%
DO WHILE CodeSize% > BitsIn%: GOSUB ReadBufferedByte: LastChar% = A%
shift left a%,bitsin%: WorkCode% = WorkCode% OR A%: INCR BitsIn%,8: LOOP
BitsIn% = BitsIn% - CodeSize%: Code% = WorkCode% AND MaxCode%: RETURN
ReadBufferedByte:
IF BlockPointer% > BlockSize% THEN GOSUB GetByte: BlockSize% = A%: GET$ #1,blocksize% , A$: BlockPointer% = 1
A% = ASC(MID$(A$, BlockPointer%, 1)): INCR BlockPointer%: RETURN
END SUB

SUB ReadPlgHeader (file$)
OPEN file$ FOR INPUT AS 1
LINE INPUT #1, lbuf$: lps = INSTR(ltrim$(lbuf$), " ")
objname$ = LEFT$(lbuf$, lps): lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$): lps = INSTR(lbuf$, " ")
pnt% = VAL(LEFT$(lbuf$, lps)): lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
lbuf$ = LTRIM$(lbuf$): pol% = VAL(LEFT$(lbuf$, lps))
FOR i% = 1 TO pnt%: LINE INPUT #1, lbuf$: NEXT i%: prl%=0
FOR i% = 1 TO pol%
  LINE INPUT #1, lbuf$: lbuf$ = LTRIM$(lbuf$):lps = INSTR(lbuf$, " ")
  nop = VAL(LEFT$(lbuf$, lps)): lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
  lbuf$ = LTRIM$(lbuf$): lps = INSTR(lbuf$, " "): nop = VAL(LEFT$(lbuf$, lps))
  IF nop = 4 THEN prl% = prl% + 2 ELSE prl% = prl% + 1
NEXT i%
pol%=prl%: CLOSE
END SUB

SUB ReadPlgObject (file$, pnt%, pol%)
OPEN file$ FOR INPUT AS 1: LINE INPUT #1, lbuf$
FOR i% = 1 TO pnt%
  LINE INPUT #1, lbuf$: lbuf$ = LTRIM$(lbuf$): lps = INSTR(lbuf$, " ")
  xd(i%) = VAL(LEFT$(lbuf$, lps)): lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
  lbuf$ = LTRIM$(lbuf$): lps = INSTR(lbuf$, " ")
  yd(i%) = VAL(LEFT$(lbuf$, lps)): lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
  lbuf$ = LTRIM$(lbuf$): zd(i%) = VAL(lbuf$)
NEXT i%
FOR i% = 1 TO pol%
  LINE INPUT #1, lbuf$: lbuf$ = LTRIM$(lbuf$)
  lps = INSTR(lbuf$, " "): nop = VAL(LEFT$(lbuf$, lps))
  lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps): lbuf$ = LTRIM$(lbuf$)
  lps = INSTR(lbuf$, " "): nop = VAL(LEFT$(lbuf$, lps))
  lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps): lbuf$ = LTRIM$(lbuf$)
  lps = INSTR(lbuf$, " "): poly(i%, 1) = VAL(LEFT$(lbuf$, lps)) + 1
  lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps): lbuf$ = LTRIM$(lbuf$)
  lps = INSTR(lbuf$, " "): poly(i%, 2) = VAL(LEFT$(lbuf$, lps)) + 1
  lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
  lbuf$ = LTRIM$(lbuf$): lps = INSTR(lbuf$, " ")
  IF nop = 3 THEN
    poly(i%, 3) = VAL(lbuf$) + 1
  else
    poly(i%, 3) = VAL(left$(lbuf$,lps)) + 1
    lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
    lbuf$ = LTRIM$(lbuf$): lps = INSTR(lbuf$, " "): pol4 = VAL(lbuf$) + 1
    pol1 = poly(i%, 1): pol2 = poly(i%, 2): pol3 = poly(i%, 3)
    poly(i%, 1) = pol1: poly(i%, 2) = pol2: poly(i%, 3) = pol3: i% = i% + 1
    poly(i%, 1) = pol3: poly(i%, 2) = pol4: poly(i%, 3) = pol1
  END IF
NEXT i%
CLOSE

PRINT "Computing normals of the points..."
FOR i% = 1 TO pol%
 normx## = ((yd(poly(i%, 1)) - yd(poly(i%, 2))) * (zd(poly(i%, 2)) - zd(poly(i%, 3)))) - ((zd(poly(i%, 1)) - zd(poly(i%, 2))) * (yd(poly(i%, 2)) - yd(poly(i%, 3))))
 normy## = ((zd(poly(i%, 1)) - zd(poly(i%, 2))) * (xd(poly(i%, 2)) - xd(poly(i%, 3)))) - ((xd(poly(i%, 1)) - xd(poly(i%, 2))) * (zd(poly(i%, 2)) - zd(poly(i%, 3))))
 normz## = ((xd(poly(i%, 1)) - xd(poly(i%, 2))) * (yd(poly(i%, 2)) - yd(poly(i%, 3)))) - ((yd(poly(i%, 1)) - yd(poly(i%, 2))) * (xd(poly(i%, 2)) - xd(poly(i%, 3))))
 nor## = SQR(normx## ^ 2 + normy## ^ 2 + normz## ^ 2)
 IF nor## <> 0 THEN norm(i%, 1) = normx## / nor##: norm(i%, 2) = normy## / nor##: norm(i%,3) = normz## / nor##
NEXT i%
dp! = 100 / pnt%: df! = 0: LOCATE 18, 55: PRINT "% done"
FOR i% = 1 TO pnt%
  df! = df! + dp!: LOCATE 18, 50: PRINT INT(df!)
  normx## = 0: normy## = 0: normz## = 0
  FOR t% = 1 TO pol%
    IF poly(t%, 1) = i% OR poly(t%, 2) = i% OR poly(t%, 3) = i% THEN
      normx## = normx## + norm(t%, 1)
      normy## = normy## + norm(t%, 2)
      normz## = normz## + norm(t%, 3)
    END IF
  NEXT t%
  nor## = SQR(normx## ^ 2 + normy## ^ 2 + normz## ^ 2)
  IF nor## <> 0 THEN pnorm(i%, 1) = normx## / nor##: pnorm(i%, 2) = normy## / nor##: pnorm(i%,3) = normz## / nor##
NEXT i%

PRINT "centering and normalizing the object..."
maxx! = xd(1): minx! = xd(1): maxy! = yd(1)
miny! = yd(1): maxz! = zd(1): minz! = zd(1)
FOR i% = 1 TO pnt%
  IF maxx! < xd(i%) THEN maxx! = xd(i%)
  IF minx! > xd(i%) THEN minx! = xd(i%)
  IF maxy! < yd(i%) THEN maxy! = yd(i%)
  IF miny! > yd(i%) THEN miny! = yd(i%)
  IF maxz! < zd(i%) THEN maxz! = zd(i%)
  IF minz! > zd(i%) THEN minz! = zd(i%)
NEXT i%
normx! = (maxx! + minx!) / 2
normy! = (maxy! + miny!) / 2
normz! = (maxz! + minz!) / 2
IF maxx! > maxy! THEN s1! = maxx! ELSE s1! = maxy!
IF s1! < maxz! THEN s1! = maxz!
IF s1! <> 0 THEN s2## = 60 / s1! ELSE s2## = 1
FOR i% = 1 TO pnt%
  xd(i%) = (xd(i%) - normx!) * s2##
  yd(i%) = (yd(i%) - normy!) * s2##
  zd(i%) = (zd(i%) - normz!) * s2##
NEXT i%
END SUB